---
title: Recommended Drag Types
slug: Web/API/HTML_Drag_and_Drop_API/Recommended_drag_types
tags:
  - Guide
  - drag and drop
---
<p>{{DefaultAPISidebar("HTML Drag and Drop API")}}</p>

<p>The HTML Drag and Drop API supports dragging various types of data, including plain text, URLs, HTML code, files, etc. The document describes best practices for common draggable data types.</p>

<div class="overheadIndicator nonStandard nonStandardHeader">
<p><strong>Caution:</strong><br>
 All methods and properties in this document with a <code>moz</code> prefix, such as <code>mozSetDataAt()</code>, will <strong>only</strong> work with Gecko-based browsers.</p>
</div>

<h2 id="text">Dragging Text</h2>

<p>For dragging text, use the <code>text/plain</code> type. The second data parameter should be the dragged string. For example:</p>

<pre class="brush: js">event.dataTransfer.setData("text/plain", "This is text to drag");
</pre>

<p>Dragging text in textboxes and selections on web pages is done automatically by the browser, so you do not need to handle it yourself.</p>

<p>It is recommended to always add data of the <code>text/plain</code> type as a fallback for applications or drop targets that do not support other types, unless there is no logical text alternative. Always add this <code>text/plain</code> type last, as it is the least specific and shouldn’t be preferred.</p>

<p class="note">Note: In older code, you may find <code>text/unicode</code> or the <code>Text</code> types. These are equivalent to <code>text/plain</code>, and will store and retrieve plain text data.</p>

<h2 id="link">Dragging Links</h2>

<p>Dragged hyperlinks should include data of two types: <code>text/uri-list</code>, and <code>text/plain</code>. <em>Both</em> types should use the link’s URL for their data. For example:</p>

<pre class="brush: js">var dt = event.dataTransfer;
dt.setData("text/uri-list", "https://www.mozilla.org");
dt.setData("text/plain", "https://www.mozilla.org");
</pre>

<p>As usual, set the <code>text/plain</code> type last, as a fallback for the <code>text/uri-list</code> type.</p>

<p class="note">Note: the URL type is <code>ur<em><strong>i</strong></em>-list</code> with an <em>I</em>, not an <em>L</em>.</p>

<p>To drag multiple links, separate each link inside the <code>text/uri-list</code> data with a CRLF linebreak. Lines that begin with a number sign (<code>#</code>) are comments, and should not be considered URLs. You can use comments to indicate the purpose of a URL, the title associated with a URL, or other data.</p>

<div class="notecard warning">
<p>The <code>text/plain</code> fallback for multiple links should include all URLs, but no comments.</p>
</div>

<p>For example, this sample <code>text/uri-list</code> data contains two links and a comment:</p>

<pre>http://www.mozilla.org
#A second link
http://www.example.com
</pre>

<p>When retrieving a dropped link, ensure you handle when multiple links are dragged, including any comments. For convenience, the special type <code>URL</code> may be used to refer to the first valid link within data for the <code>text/uri-list</code> type.</p>

<div class="notecard warning">
<p>Do not add data with the <code>URL</code> type — attempting to do so will set the value of the <code>text/uri-list</code> type instead.</p>
</div>

<pre class="brush: js">var url = event.dataTransfer.getData("URL");
</pre>

<p>You may also see data with the Mozilla-specific type <code>text/x-moz-url</code>. If it appears, it should appear before the <code>text/uri-list</code> type. It holds the URLs of links followed by their titles, separated by a linebreak. For example:</p>

<pre>http://www.mozilla.org
Mozilla
http://www.example.com
Example
</pre>

<h2 id="html">Dragging HTML and XML</h2>

<p>HTML content may use the <code>text/html</code> type. The data for this type should be serialized HTML source code. For example, it would be suitable to set its data to the value of the <code>{{domxref("Element.innerHTML","innerHTML")}}</code> property of an element.</p>

<p>XML content may use the <code>text/xml</code> type, but ensure that the data is well-formed XML.</p>

<p>You may also include a plain text representation of the HTML or XML data using the <code>text/plain</code> type. The data should be just the text without any of the source tags or attributes. For instance:</p>

<pre class="brush: js">var dt = event.dataTransfer;
dt.setData("text/html", "Hello there, &lt;strong&gt;stranger&lt;/strong&gt;");
dt.setData("text/plain", "Hello there, stranger");
</pre>

<h2 id="file">Dragging Files</h2>

<p>A local file is dragged using the <code>application/x-moz-file</code> type with a data value that is an <a href="/en/XPCOM_Interface_Reference/nsIFile" title="nsIFile">nsIFile</a> object. Non-privileged web pages canot retrieve or modify data of this type.</p>

<p>Because a file is not a string, you must use the {{domxref("DataTransfer.mozSetDataAt","mozSetDataAt()")}} method to assign the data. Similarly, when retrieving the data, you must use the {{domxref("DataTransfer.mozGetDataAt","mozGetDataAt()")}} method.</p>

<pre class="brush: js">event.dataTransfer.mozSetDataAt("application/x-moz-file", file, 0);
</pre>

<p>If possible, include the file URL of the file using both the <code>text/uri-list</code> and <code>text/plain</code> types. These types should be added afterward so that the more specific <code>application/x-moz-file</code> type has higher priority.</p>

<p>Multiple files will be received during a drop as multiple items in the data transfer. See <a href="/En/DragDrop/Dragging_and_Dropping_Multiple_Items" title="Dragging and Dropping Multiple Items">Dragging and Dropping Multiple Items</a> for more details about this.</p>

<p>The following example shows how to create an area for receiving dropped files:</p>

<pre class="brush: xml">&lt;listbox ondragenter="return checkDrag(event)"
         ondragover="return checkDrag(event)"
         ondrop="doDrop(event)"/&gt;

&lt;script&gt;
function checkDrag(event) {
  return event.dataTransfer.types.contains("application/x-moz-file");
}

function doDrop(event) {
  var file = event.dataTransfer.mozGetDataAt("application/x-moz-file", 0);
  if (file instanceof Components.interfaces.nsIFile) {
    event.currentTarget.appendItem(file.leafName);
  }
}
&lt;/script&gt;
</pre>

<p>In this example, the event returns false only if the data transfer contains the <code>application/x-moz-file</code> type. During the drop event, the data associated with the file type is retrieved, and the filename of the file is added to the listbox. Note that the <code>instanceof</code> operator is used here as the {{domxref("DataTransfer.mozGetDataAt","mozGetDataAt()")}} method will return an <code>nsISupports</code> that needs to be checked and converted into an nsIFile. This is also a good extra check in case someone made a mistake and added a non-file for this type.</p>

<h3 id="Updates_to_DataTransfer.types">Updates to DataTransfer.types</h3>

<p>The latest spec dictates that {{domxref("DataTransfer.types")}} should return a frozen array of {{domxref("DOMString")}}s rather than a {{domxref("DOMStringList")}} (this is supported in Firefox 52 and above).</p>

<p>As a result, the <a href="/en-US/docs/Web/API/Node/contains">contains</a> method no longer works; the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/includes">includes</a> method should be used instead to check if a specific type of data is provided, using code like the following:</p>

<pre class="brush: js">if ([...event.dataTransfer.types].includes('text/html')) {
  // Do something
}</pre>

<p>You could use feature detection to determine which method is supported on <code>types</code>, then run code as appropriate.</p>

<h2 id="image">Dragging Images</h2>

<p>Direct image dragging is not common. In fact, Mozilla does not support direct image dragging on Mac or Linux. Instead, images are usually dragged only by their URLs. To do this, use the <code>text/uri-list</code> type as with other URLs. The data should be the URL of the image, or a <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs"><code>data:</code> URI</a> if the image is not stored on a web site or disk.</p>

<p>As with links, the data for the <code>text/plain</code> type should also contain the URL. However, a <code>data:</code> URL is not usually useful in a text context, so you may wish to exclude the <code>text/plain</code> data in this situation.</p>

<p>In chrome or other privileged code, you may also use the <code>image/jpeg</code>, <code>image/png</code> or <code>image/gif</code> types, depending on the type of image. The data should be an object which implements the <a href="/en/XPCOM_Interface_Reference/nsIInputStream" title="nsIInputStream">nsIInputStream</a> interface. When this stream is read, it should provide the data bits for the image, as if the image was a file of that type.</p>

<p>You should also include the <code>application/x-moz-file</code> type if the image is located on disk. In fact, this a common way in which image files are dragged.</p>

<p>It is important to set the data in the right order, from most-specific to least-specific. The standard image type, such as <code>image/jpeg</code>, should come first, followed by the <code>application/x-moz-file</code> type. Next, you should set the <code>text/uri-list</code> data, and finally the <code>text/plain</code> data. For example:</p>

<pre class="brush: js">var dt = event.dataTransfer;
dt.mozSetDataAt("image/png", stream, 0);
dt.mozSetDataAt("application/x-moz-file", file, 0);
dt.setData("text/uri-list", imageurl);
dt.setData("text/plain", imageurl);
</pre>

<p>Note the {{domxref("DataTransfer.mozGetDataAt","mozGetDataAt()")}} method is used for non-textual data. As some contexts may only include some of these types, it is important to check which type is made available when receiving dropped images.</p>

<h2 id="node">Dragging Nodes</h2>

<p>Nodes and elements in a document may be dragged using the <code>application/x-moz-node</code> type. The data for the type should be a DOM node. This allows the drop target to receive the actual node where the drag was started from. Note that callers from a different domain will not be able to access the node even when it has been dropped.</p>

<p>You should always include a <code>text/plain</code> alternative for the node.</p>

<h2 id="custom">Dragging Custom Data</h2>

<p>You can also use other types that you invent for custom purposes. Strive to always include a <code>text/plain</code> alternative, unless the dragged object is specific to a particular site or application. In this case, the custom type ensures that the data cannot be dropped elsewhere.</p>

<h2 id="filestoos">Dragging files to an operating system folder</h2>

<p>You may want to add a file to an existing drag event session, and you may also want to write the file to disk when the drop operation happens over a folder in the operating system when your code receives notification of the target folder's location. This only works in extensions (or other privileged code) and the type <code>application/moz-file-promise</code> should be used. The following sample offers an overview of this advanced case:</p>

<pre class="brush: js">// currentEvent is an existing drag operation event

currentEvent.dataTransfer.setData("text/x-moz-url", URL);
currentEvent.dataTransfer.setData("application/x-moz-file-promise-url", URL);
currentEvent.dataTransfer.setData("<span class="p">application/x-moz-file-promise-dest-filename</span>", leafName);
currentEvent.dataTransfer.mozSetDataAt('application/x-moz-file-promise',
                  new dataProvider(success,error),
                  0, Components.interfaces.nsISupports);

function dataProvider(){}

dataProvider.prototype = {
  QueryInterface : function(iid) {
    if (iid.equals(Components.interfaces.nsIFlavorDataProvider)
                  || iid.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
  getFlavorData : function(aTransferable, aFlavor, aData, aDataLen) {
    if (aFlavor == 'application/x-moz-file-promise') {

       var urlPrimitive = {};
       var dataSize = {};

       aTransferable.getTransferData('application/x-moz-file-promise-url', urlPrimitive, dataSize);
       var url = urlPrimitive.value.QueryInterface(Components.interfaces.nsISupportsString).data;
       console.log("URL file orignal is = " + url);

       var namePrimitive = {};
       aTransferable.getTransferData('<span class="p">application/x-moz-file-promise-dest-filename</span>', namePrimitive, dataSize);
       var name = namePrimitive.value.QueryInterface(Components.interfaces.nsISupportsString).data;

       console.log("target filename is = " + name);

       var dirPrimitive = {};
       aTransferable.getTransferData('application/x-moz-file-promise-dir', dirPrimitive, dataSize);
       var dir = dirPrimitive.value.QueryInterface(Components.interfaces.nsILocalFile);

       console.log("target folder is = " + dir.path);

       var file = Cc['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
       file.initWithPath(dir.path);
       file.appendRelativePath(name);

       console.log("output final path is =" + file.path);

       // now you can write or copy the file yourself…
    }
  }
}
</pre>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a class="internal" href="/Web/API/HTML_Drag_and_Drop_API" title="HTML Drag and Drop API">HTML Drag and Drop API (Overview)</a></li>
 <li><a class="internal" href="Web/Guide/HTML/Drag_operations" title="Drag Operations">Drag Operations</a></li>
 <li><a class="internal" href="/Web/Guide/HTML/Dragging_and_Dropping_Multiple_Items" title="Dragging and Dropping Multiple Items">Dragging and Dropping Multiple Items</a></li>
 <li><a href="https://html.spec.whatwg.org/multipage/interaction.html#dnd" title="Drag and Drop Standard">HTML5 Living Standard: Drag and Drop</a></li>
</ul>
